package smarthome;

import com.sun.xml.internal.ws.policy.EffectiveAlternativeSelector;
import javafx.scene.chart.PieChart;
import org.json.JSONException;
import org.json.JSONObject;
import org.omg.PortableInterceptor.SYSTEM_EXCEPTION;

import javax.lang.model.util.ElementScanner6;
import javax.print.attribute.standard.DateTimeAtCreation;
import javax.swing.plaf.synth.SynthButtonUI;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.logging.Logger;

/**
 * Created by Visen (zhvisen@gmail.com) on 2016/5/12.
 */
public class ServerHandler implements Handler {

    private static final Logger log = Logger.getLogger(ServerHandler.class.getName());

    @Override
    public void handleAccept(SelectionKey key) throws IOException {
        try {
            ServerSocketChannel serverSocketChannel = (ServerSocketChannel)key.channel();
            SocketChannel socketChannel = serverSocketChannel.accept();
            log.info("Server: accept client socket " + socketChannel);
            socketChannel.configureBlocking(false);
            socketChannel.register(key.selector(), SelectionKey.OP_READ);
        }
        catch (Exception e)
        {
            log.info("distinct by client!!!!");

        }



    }

    @Override
    public void handleRead(SelectionKey key) throws IOException {
        log.info("read");
        ByteBuffer byteBuffer = ByteBuffer.allocate(512);
        SocketChannel socketChannel = (SocketChannel)key.channel();
       // while(true) {
            try{
                    int readBytes = socketChannel.read(byteBuffer);
                    if(readBytes>0) {
                        log.info("Server: readBytes = " + readBytes);
                        String recvString = new String(byteBuffer.array(),0,readBytes) ;
                        log.info("Server: data = " + recvString);
                        //System.out.println("Server: data = " + new String(byteBuffer.array(), 0, readBytes));
                        String ret = (new CommonTimeJsonObj()).getObjectJsonString();
                        try {
                            StateJsonObj stateJosonObj = JSONHelper.ParseJSON(recvString);
                            if(stateJosonObj.getAmount()==-1  )///// send the timing or realtime task or the time
                            {
                                DBUtil dbUtil1=new DBUtil();
                                dbUtil1.openConnection();

                                DBUtil dbUtil2 = new DBUtil();
                                dbUtil2.openConnection();
                                String queryrealtime = "select * from realtimetasks where setflag='0' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";

                                String querytiming = "select * from timingtasks where setflag='0' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";

                                int flag=0;

                                ResultSet resultSetRealTime = dbUtil1.executeQuery(queryrealtime);

                                String s1="";
                                try {                       /////////////////////////实时任务
                                    //rs.first();
                                    while (resultSetRealTime.next())
                                    {

                                        RealTimeTaskJsonObj realTimeTaskJsonObj = new RealTimeTaskJsonObj("1",resultSetRealTime.getInt(6),resultSetRealTime.getInt(3));
                                        s1 = realTimeTaskJsonObj.getObjectJsonString();
                                        flag=1;
                                    }


                                }catch (SQLException e)
                                {
                                    e.printStackTrace();

                                }

                                if(flag ==0)
                                {
                                    ResultSet resultSetTiming = dbUtil2.executeQuery(querytiming);
                                    try {
                                        //rs.first();
                                        while (resultSetTiming.next())
                                        {
                                            TimingTaskJsonObj timingTaskJsonObj =new TimingTaskJsonObj("0",resultSetTiming.getInt(7),resultSetTiming.getString(2),resultSetTiming.getString(4),resultSetTiming.getInt(3));
                                            s1 = timingTaskJsonObj.getObjectJsonString();
                                            flag=2;

                                        }

                                    }catch (SQLException e)
                                    {
                                        e.printStackTrace();

                                    }
                                }

                                ret = s1;
                                if(flag==0)
                                {
                                    /////补充取消任务的相关查询

                                    String sqlrealtime = "select * from realtimetasks where setflag='3' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id  limit 1 ";
                                    String sqltiming = "select * from timingtasks where setflag='3' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id  limit 1 ";

                                    String updaterealtime ="update realtimetasks set setflag='4' where setflag='3' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id  limit 1 ";
                                    String updatetiming ="update timingtasks set setflag='4' where setflag='3' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id  limit 1 ";


                                    DBUtil dbUtil3=new DBUtil();
                                    dbUtil3.openConnection();

                                    DBUtil dbUtil4 = new DBUtil();
                                    dbUtil4.openConnection();

                                    try{
                                        ResultSet resultSet3 = dbUtil3.executeQuery(sqlrealtime);
                                        ResultSet resultSet4 = dbUtil4.executeQuery(sqltiming);

                                        String s4="";

                                        try {
                                            //rs.first();
                                            while (resultSet3.next())
                                            {
                                                RealTimeTaskJsonObj realTimeTaskJsonObj = new RealTimeTaskJsonObj("1",resultSet3.getInt(6),0);
                                                s4 = realTimeTaskJsonObj.getObjectJsonString();
                                                flag =4;
                                            }
                                            dbUtil3.executeUpdate(updaterealtime);

                                        }catch (SQLException e)
                                        {
                                            e.printStackTrace();

                                        }

                                        if(flag==0)
                                        {

                                            try {

                                                while (resultSet4.next())
                                                {
                                                    TimingTaskJsonObj timingTaskJsonObj =new TimingTaskJsonObj("0",resultSet4.getInt(7),resultSet4.getString(2),resultSet4.getString(4),0);
                                                    s4 = timingTaskJsonObj.getObjectJsonString();
                                                    flag =3;
                                                }
                                                dbUtil4.executeUpdate(updatetiming);
                                            }catch (SQLException e)
                                            {
                                                e.printStackTrace();

                                            }

                                        }

                                        if(flag==0)
                                        {
                                            CommonTimeJsonObj commonTimeJsonObj = new CommonTimeJsonObj();
                                            ret = commonTimeJsonObj.getObjectJsonString();
                                        }
                                        else
                                        {
                                            ret = s4;
                                        }

                                    }
                                    catch (Exception e)
                                    {
                                        e.printStackTrace();

                                    }


                                    dbUtil3.closeConnection();
                                    dbUtil4.closeConnection();

                                }

                                dbUtil1.closeConnection();
                                dbUtil2.closeConnection();

                                log.info("111111111111");

                                byteBuffer.flip();
                                socketChannel.write(byteBuffer.wrap(ret.getBytes()));
                                byteBuffer.clear();

                            }
                            else if(stateJosonObj.getAmount()==-2)  ////////update the history data for the device
                            {
                                DBUtil dbUtil1=new DBUtil();
                                dbUtil1.openConnection();

                                DBUtil dbUtil2 = new DBUtil();
                                dbUtil2.openConnection();

                                String sqlstrrealtime1 = "update realtimetasks set setflag='2' where setflag='1' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";
                                String sqlstrtiming2 = "update timingtasks set setflag='2' where setflag='1' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";

                                dbUtil1.executeUpdate(sqlstrrealtime1);
                                dbUtil2.executeUpdate(sqlstrtiming2);

                                dbUtil1.closeConnection();
                                dbUtil2.closeConnection();

                                log.info("2222222222");
                                ret="";
                                byteBuffer.flip();
                                socketChannel.write(byteBuffer.wrap(ret.getBytes()));
                                byteBuffer.clear();

                            }
                            else if(stateJosonObj.getAmount()>0)
                            {

                                DBUtil dbUtil=new DBUtil();
                                dbUtil.openConnection();

                                String sqlstrrealtime = "update realtimetasks set setflag='1' where setflag='0' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";
                                String sqlstrtiming = "update timingtasks set setflag='1' where setflag='0' and deviceid='"+stateJosonObj.getDeviceid()+"' ORDER BY id DESC limit 1 ";

                                Calendar cal1 = Calendar.getInstance();
                                TimeZone.setDefault(TimeZone.getTimeZone("GMT+8:00"));
                                java.text.SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd kk:mm:ss");
                                String time = sdf.format(cal1.getTime());
                                int deviceid = stateJosonObj.getDeviceid();
                                int amount = stateJosonObj.getAmount();

                                String sqlinsert = "insert into historydatas(starttime,amount,device_id) VALUES('"+time+"','"+amount+"','"+deviceid+"')";

                                try {

                                    if(dbUtil.executeUpdate(sqlstrrealtime)==0)
                                    {
                                        dbUtil.executeUpdate(sqlstrtiming);
                                    }

                                    dbUtil.executeUpdate(sqlinsert);

                                }
                                catch (Exception e)
                                {
                                    e.printStackTrace();
                                }

                                dbUtil.closeConnection();

                                log.info("333333333333");
                                ret="";
                                byteBuffer.flip();
                                socketChannel.write(byteBuffer.wrap(ret.getBytes()));
                                byteBuffer.clear();

                            }

                        }

                        catch (Exception e)
                        {
                            e.printStackTrace();
                        }

                    }
                    else
                    {
                       // break;
                    }
               // break;
            }catch (Exception e){
                e.printStackTrace();
                log.info("cancel");
                key.cancel();
               // break;
            }

        //}
        socketChannel.close();
    }

    @Override
    public void handleWrite(SelectionKey key) throws IOException {
        ByteBuffer byteBuffer = (ByteBuffer) key.attachment();
        byteBuffer.flip();
        SocketChannel socketChannel = (SocketChannel)key.channel();
        socketChannel.write(byteBuffer);
        if(byteBuffer.hasRemaining()) {
            key.interestOps(SelectionKey.OP_READ);
        }
        byteBuffer.compact();
    }



 /*   public int getRealTimeAmount(ResultSet rs)
    {
        int amount =0;
        try {
            rs.first();
            while (rs.next())
            {
                amount=Integer.parseInt(rs.getString(3));
            }
        }catch (SQLException e)
        {
            e.printStackTrace();
        }
        return amount;
    }

    public int getTimingAmount(ResultSet rs)
    {
        int amount =0;
        try {
            rs.first();
            while (rs.next())
            {
                amount=Integer.parseInt(rs.getString(2));
            }
        }catch (SQLException e)
        {
            e.printStackTrace();
        }
        return amount;
    }

*/

 /*   public String generateTimingStr(ResultSet rs)
    {
        String ret="";
        try {
            //rs.first();
            while (rs.next())
            {
                TimingTaskJsonObj timingTaskJsonObj =new TimingTaskJsonObj("0",rs.getString(1),rs.getString(2),rs.getString(4),rs.getString(3));
                ret = timingTaskJsonObj.getObjectJsonString();
            }
        }catch (SQLException e)
        {
            e.printStackTrace();
        }

        return ret;
    }

    public String generateRealTimeStr(ResultSet rs)
    {
        String ret="";
        try {
            //rs.first();
            while (rs.next())
            {
                RealTimeTaskJsonObj realTimeTaskJsonObj = new RealTimeTaskJsonObj("1",rs.getString(1),rs.getString(2));
                ret = realTimeTaskJsonObj.getObjectJsonString();
            }

        }catch (SQLException e)
        {
            e.printStackTrace();

        }
        return ret;

    }

*/
/*
    public String getRetJSONStr(String realTimeStr,String timingStr){

        if(realTimeStr.equals("") && timingStr.equals(""))/////���߶�Ϊ�յ�ʱ�� �ظ�������ʱ��
        {
            CommonTimeJsonObj commonTimeJsonObj = new CommonTimeJsonObj();
            return commonTimeJsonObj.getObjectJsonString();
        }
        if(realTimeStr.equals(""))
        {
            return timingStr;
        }
        if(timingStr.equals(""))
        {
            return realTimeStr;
        }
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("realtimetask",realTimeStr);
            jsonObject.put("timingtask",timingStr);
        }
        catch (JSONException e)
        {
            e.printStackTrace();
        }
        return jsonObject.toString();
    }
*/




}
